package logger

import (
	"context"
	"log"

	"github.com/aws/aws-lambda-go/events"
	"github.com/aws/aws-lambda-go/lambda"
)

func Run() {
	lambda.Start(run)
}

func run(ctx context.Context, event events.KinesisEvent) error {
	for _, record := range event.Records {
		log.Println(record.EventID, string(record.Kinesis.Data))
	}

	return nil
}
