// Code generated by protoc-gen-twirp v5.12.1, DO NOT EDIT.
// source: code.justin.tv/amzn/TwitchSafetyAutoModTwirp/twirp.proto

/*
Package TwitchSafetyAutoModTwirp is a generated twirp stub package.
This code was generated with github.com/twitchtv/twirp/protoc-gen-twirp v5.12.1.

It is generated from these files:
	code.justin.tv/amzn/TwitchSafetyAutoModTwirp/automod.proto
	code.justin.tv/amzn/TwitchSafetyAutoModTwirp/caughtMessages.proto
	code.justin.tv/amzn/TwitchSafetyAutoModTwirp/evaluations.proto
	code.justin.tv/amzn/TwitchSafetyAutoModTwirp/pagination.proto
	code.justin.tv/amzn/TwitchSafetyAutoModTwirp/terms.proto
	code.justin.tv/amzn/TwitchSafetyAutoModTwirp/twirp.proto
*/
package TwitchSafetyAutoModTwirp

import bytes "bytes"
import strings "strings"
import context "context"
import fmt "fmt"
import ioutil "io/ioutil"
import http "net/http"
import strconv "strconv"

import jsonpb "github.com/golang/protobuf/jsonpb"
import proto "github.com/golang/protobuf/proto"
import twirp "github.com/twitchtv/twirp"
import ctxsetters "github.com/twitchtv/twirp/ctxsetters"

// Imports only used by utility functions:
import io "io"
import json "encoding/json"
import url "net/url"

// =============================
// TwitchSafetyAutoMod Interface
// =============================

type TwitchSafetyAutoMod interface {
	// An operation to create an entry for a message caught by AutoMod.
	CreateCaughtMessage(context.Context, *CreateCaughtMessageRequest) (*CreateCaughtMessageResponse, error)

	// A bulk operation for updating the fields status of caught messages.
	UpdateCaughtMessages(context.Context, *UpdateCaughtMessagesRequest) (*UpdateCaughtMessagesResponse, error)

	// A bulk operation for getting messages caught by AutoMod.
	BulkGetCaughtMessages(context.Context, *BulkGetCaughtMessagesRequest) (*BulkGetCaughtMessagesResponse, error)

	// An operation to list all caught messages for a particular sender.
	ListCaughtMessagesBySender(context.Context, *ListCaughtMessagesBySenderRequest) (*ListCaughtMessagesBySenderResponse, error)

	// An operation to get the AutoMod category levels for a channel
	GetChannelAutoModProperties(context.Context, *GetChannelAutoModPropertiesRequest) (*GetChannelAutoModPropertiesResponse, error)

	// An operation to set the AutoMod category levels for a channel
	SetChannelAutoModProperties(context.Context, *SetChannelAutoModPropertiesRequest) (*SetChannelAutoModPropertiesResponse, error)

	// An operation to set the AutoMod category levels, using 4 Sift categories, for a channel
	SetChannelSiftAutoModProperties(context.Context, *SetChannelSiftAutoModPropertiesRequest) (*SetChannelSiftAutoModPropertiesResponse, error)

	// An operation to get the AutoMod category levels, using 4 Sift categories, for a channel
	GetChannelSiftAutoModProperties(context.Context, *GetChannelSiftAutoModPropertiesRequest) (*GetChannelSiftAutoModPropertiesResponse, error)

	// An operation to delete AutoMod category settings for a channel (used for hard delete of user).
	DeleteChannelAutoModProperties(context.Context, *DeleteChannelAutoModPropertiesRequest) (*DeleteChannelAutoModPropertiesResponse, error)

	// An operation to enable AutoMod (set to level 1) on channels that meet certain requirements (currently: channel has no mods and channel has never modified AutoMod settings previously)
	EnableDefaultAutoModLevel(context.Context, *EnableDefaultAutoModLevelRequest) (*EnableDefaultAutoModLevelResponse, error)

	// An operation to apply AutoMod Ally enforcement to content.
	AllyEnforcement(context.Context, *AllyEnforcementRequest) (*AllyEnforcementResponse, error)

	// An operation to determine whether a channel is reliant on Ally for enforcement.
	AllyEnforcementBucketMember(context.Context, *AllyEnforcementBucketMemberRequest) (*AllyEnforcementBucketMemberResponse, error)

	// An operation to retrieve all global blocked terms on Twitch
	GetGlobalBlockedTerms(context.Context, *GetGlobalBlockedTermsRequest) (*GetGlobalBlockedTermsResponse, error)

	// An operation to add a global blocked term on Twitch
	AddGlobalBlockedTerm(context.Context, *AddGlobalBlockedTermRequest) (*AddGlobalBlockedTermResponse, error)

	// An operation to delete a global blocked term on Twitch
	DeleteGlobalBlockedTerm(context.Context, *DeleteGlobalBlockedTermRequest) (*DeleteGlobalBlockedTermResponse, error)

	// An operation to retrieve all blocked terms for a channel
	ListChannelBlockedTerms(context.Context, *ListChannelBlockedTermsRequest) (*ListChannelBlockedTermsResponse, error)

	// An operation to retrieve all permitted terms for a channel
	ListChannelPermittedTerms(context.Context, *ListChannelPermittedTermsRequest) (*ListChannelPermittedTermsResponse, error)

	// An operation to allow automod testing on words, includes channel blocked and permitted terms.
	TestAutoModEnforcementOnMessage(context.Context, *TestAutoModEnforcementOnMessageRequest) (*TestAutoModEnforcementOnMessageResponse, error)

	// An operation to add a blocked term to a channel
	AddChannelBlockedTerm(context.Context, *AddChannelBlockedTermRequest) (*AddChannelBlockedTermResponse, error)

	// An operation to add a permitted term to a channel
	AddChannelPermittedTerm(context.Context, *AddChannelPermittedTermRequest) (*AddChannelPermittedTermResponse, error)

	// An operation to delete a blocked term to a channel
	DeleteChannelBlockedTerm(context.Context, *DeleteChannelBlockedTermRequest) (*DeleteChannelBlockedTermResponse, error)

	// An operation to delete a permitted term to a channel
	DeleteChannelPermittedTerm(context.Context, *DeleteChannelPermittedTermRequest) (*DeleteChannelPermittedTermResponse, error)

	// An operation to process a message according to defined evaluation engine rules (classification using Ally, global blocked terms, and/or channel blocked terms).
	EvaluateMessage(context.Context, *EvaluateMessageRequest) (*EvaluateMessageResponse, error)

	// An operation to validate responses from classfication to use them for future integration tests.
	ValidateAutoModContent(context.Context, *ValidateAutoModContentRequest) (*ValidateAutoModContentResponse, error)

	// An operation to delete classifications used for integration tests.
	DeleteValidatedAutoModContent(context.Context, *DeleteValidatedAutoModContentRequest) (*DeleteValidatedAutoModContentResponse, error)
}

// ===================================
// TwitchSafetyAutoMod Protobuf Client
// ===================================

type twitchSafetyAutoModProtobufClient struct {
	client HTTPClient
	urls   [25]string
	opts   twirp.ClientOptions
}

// NewTwitchSafetyAutoModProtobufClient creates a Protobuf client that implements the TwitchSafetyAutoMod interface.
// It communicates using Protobuf and can be configured with a custom HTTPClient.
func NewTwitchSafetyAutoModProtobufClient(addr string, client HTTPClient, opts ...twirp.ClientOption) TwitchSafetyAutoMod {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	prefix := urlBase(addr) + TwitchSafetyAutoModPathPrefix
	urls := [25]string{
		prefix + "CreateCaughtMessage",
		prefix + "UpdateCaughtMessages",
		prefix + "BulkGetCaughtMessages",
		prefix + "ListCaughtMessagesBySender",
		prefix + "GetChannelAutoModProperties",
		prefix + "SetChannelAutoModProperties",
		prefix + "SetChannelSiftAutoModProperties",
		prefix + "GetChannelSiftAutoModProperties",
		prefix + "DeleteChannelAutoModProperties",
		prefix + "EnableDefaultAutoModLevel",
		prefix + "AllyEnforcement",
		prefix + "AllyEnforcementBucketMember",
		prefix + "GetGlobalBlockedTerms",
		prefix + "AddGlobalBlockedTerm",
		prefix + "DeleteGlobalBlockedTerm",
		prefix + "ListChannelBlockedTerms",
		prefix + "ListChannelPermittedTerms",
		prefix + "TestAutoModEnforcementOnMessage",
		prefix + "AddChannelBlockedTerm",
		prefix + "AddChannelPermittedTerm",
		prefix + "DeleteChannelBlockedTerm",
		prefix + "DeleteChannelPermittedTerm",
		prefix + "EvaluateMessage",
		prefix + "ValidateAutoModContent",
		prefix + "DeleteValidatedAutoModContent",
	}

	return &twitchSafetyAutoModProtobufClient{
		client: client,
		urls:   urls,
		opts:   clientOpts,
	}
}

func (c *twitchSafetyAutoModProtobufClient) CreateCaughtMessage(ctx context.Context, in *CreateCaughtMessageRequest) (*CreateCaughtMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "CreateCaughtMessage")
	out := new(CreateCaughtMessageResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) UpdateCaughtMessages(ctx context.Context, in *UpdateCaughtMessagesRequest) (*UpdateCaughtMessagesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "UpdateCaughtMessages")
	out := new(UpdateCaughtMessagesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) BulkGetCaughtMessages(ctx context.Context, in *BulkGetCaughtMessagesRequest) (*BulkGetCaughtMessagesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "BulkGetCaughtMessages")
	out := new(BulkGetCaughtMessagesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[2], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) ListCaughtMessagesBySender(ctx context.Context, in *ListCaughtMessagesBySenderRequest) (*ListCaughtMessagesBySenderResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ListCaughtMessagesBySender")
	out := new(ListCaughtMessagesBySenderResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[3], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) GetChannelAutoModProperties(ctx context.Context, in *GetChannelAutoModPropertiesRequest) (*GetChannelAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelAutoModProperties")
	out := new(GetChannelAutoModPropertiesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[4], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) SetChannelAutoModProperties(ctx context.Context, in *SetChannelAutoModPropertiesRequest) (*SetChannelAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelAutoModProperties")
	out := new(SetChannelAutoModPropertiesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[5], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) SetChannelSiftAutoModProperties(ctx context.Context, in *SetChannelSiftAutoModPropertiesRequest) (*SetChannelSiftAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelSiftAutoModProperties")
	out := new(SetChannelSiftAutoModPropertiesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[6], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) GetChannelSiftAutoModProperties(ctx context.Context, in *GetChannelSiftAutoModPropertiesRequest) (*GetChannelSiftAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelSiftAutoModProperties")
	out := new(GetChannelSiftAutoModPropertiesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[7], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) DeleteChannelAutoModProperties(ctx context.Context, in *DeleteChannelAutoModPropertiesRequest) (*DeleteChannelAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelAutoModProperties")
	out := new(DeleteChannelAutoModPropertiesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[8], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) EnableDefaultAutoModLevel(ctx context.Context, in *EnableDefaultAutoModLevelRequest) (*EnableDefaultAutoModLevelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "EnableDefaultAutoModLevel")
	out := new(EnableDefaultAutoModLevelResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[9], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) AllyEnforcement(ctx context.Context, in *AllyEnforcementRequest) (*AllyEnforcementResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcement")
	out := new(AllyEnforcementResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[10], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) AllyEnforcementBucketMember(ctx context.Context, in *AllyEnforcementBucketMemberRequest) (*AllyEnforcementBucketMemberResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcementBucketMember")
	out := new(AllyEnforcementBucketMemberResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[11], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) GetGlobalBlockedTerms(ctx context.Context, in *GetGlobalBlockedTermsRequest) (*GetGlobalBlockedTermsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "GetGlobalBlockedTerms")
	out := new(GetGlobalBlockedTermsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[12], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) AddGlobalBlockedTerm(ctx context.Context, in *AddGlobalBlockedTermRequest) (*AddGlobalBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AddGlobalBlockedTerm")
	out := new(AddGlobalBlockedTermResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[13], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) DeleteGlobalBlockedTerm(ctx context.Context, in *DeleteGlobalBlockedTermRequest) (*DeleteGlobalBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteGlobalBlockedTerm")
	out := new(DeleteGlobalBlockedTermResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[14], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) ListChannelBlockedTerms(ctx context.Context, in *ListChannelBlockedTermsRequest) (*ListChannelBlockedTermsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelBlockedTerms")
	out := new(ListChannelBlockedTermsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[15], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) ListChannelPermittedTerms(ctx context.Context, in *ListChannelPermittedTermsRequest) (*ListChannelPermittedTermsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelPermittedTerms")
	out := new(ListChannelPermittedTermsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[16], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) TestAutoModEnforcementOnMessage(ctx context.Context, in *TestAutoModEnforcementOnMessageRequest) (*TestAutoModEnforcementOnMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "TestAutoModEnforcementOnMessage")
	out := new(TestAutoModEnforcementOnMessageResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[17], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) AddChannelBlockedTerm(ctx context.Context, in *AddChannelBlockedTermRequest) (*AddChannelBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelBlockedTerm")
	out := new(AddChannelBlockedTermResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[18], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) AddChannelPermittedTerm(ctx context.Context, in *AddChannelPermittedTermRequest) (*AddChannelPermittedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelPermittedTerm")
	out := new(AddChannelPermittedTermResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[19], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) DeleteChannelBlockedTerm(ctx context.Context, in *DeleteChannelBlockedTermRequest) (*DeleteChannelBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelBlockedTerm")
	out := new(DeleteChannelBlockedTermResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[20], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) DeleteChannelPermittedTerm(ctx context.Context, in *DeleteChannelPermittedTermRequest) (*DeleteChannelPermittedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelPermittedTerm")
	out := new(DeleteChannelPermittedTermResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[21], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) EvaluateMessage(ctx context.Context, in *EvaluateMessageRequest) (*EvaluateMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateMessage")
	out := new(EvaluateMessageResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[22], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) ValidateAutoModContent(ctx context.Context, in *ValidateAutoModContentRequest) (*ValidateAutoModContentResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ValidateAutoModContent")
	out := new(ValidateAutoModContentResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[23], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModProtobufClient) DeleteValidatedAutoModContent(ctx context.Context, in *DeleteValidatedAutoModContentRequest) (*DeleteValidatedAutoModContentResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteValidatedAutoModContent")
	out := new(DeleteValidatedAutoModContentResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[24], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// ===============================
// TwitchSafetyAutoMod JSON Client
// ===============================

type twitchSafetyAutoModJSONClient struct {
	client HTTPClient
	urls   [25]string
	opts   twirp.ClientOptions
}

// NewTwitchSafetyAutoModJSONClient creates a JSON client that implements the TwitchSafetyAutoMod interface.
// It communicates using JSON and can be configured with a custom HTTPClient.
func NewTwitchSafetyAutoModJSONClient(addr string, client HTTPClient, opts ...twirp.ClientOption) TwitchSafetyAutoMod {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	prefix := urlBase(addr) + TwitchSafetyAutoModPathPrefix
	urls := [25]string{
		prefix + "CreateCaughtMessage",
		prefix + "UpdateCaughtMessages",
		prefix + "BulkGetCaughtMessages",
		prefix + "ListCaughtMessagesBySender",
		prefix + "GetChannelAutoModProperties",
		prefix + "SetChannelAutoModProperties",
		prefix + "SetChannelSiftAutoModProperties",
		prefix + "GetChannelSiftAutoModProperties",
		prefix + "DeleteChannelAutoModProperties",
		prefix + "EnableDefaultAutoModLevel",
		prefix + "AllyEnforcement",
		prefix + "AllyEnforcementBucketMember",
		prefix + "GetGlobalBlockedTerms",
		prefix + "AddGlobalBlockedTerm",
		prefix + "DeleteGlobalBlockedTerm",
		prefix + "ListChannelBlockedTerms",
		prefix + "ListChannelPermittedTerms",
		prefix + "TestAutoModEnforcementOnMessage",
		prefix + "AddChannelBlockedTerm",
		prefix + "AddChannelPermittedTerm",
		prefix + "DeleteChannelBlockedTerm",
		prefix + "DeleteChannelPermittedTerm",
		prefix + "EvaluateMessage",
		prefix + "ValidateAutoModContent",
		prefix + "DeleteValidatedAutoModContent",
	}

	return &twitchSafetyAutoModJSONClient{
		client: client,
		urls:   urls,
		opts:   clientOpts,
	}
}

func (c *twitchSafetyAutoModJSONClient) CreateCaughtMessage(ctx context.Context, in *CreateCaughtMessageRequest) (*CreateCaughtMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "CreateCaughtMessage")
	out := new(CreateCaughtMessageResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) UpdateCaughtMessages(ctx context.Context, in *UpdateCaughtMessagesRequest) (*UpdateCaughtMessagesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "UpdateCaughtMessages")
	out := new(UpdateCaughtMessagesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) BulkGetCaughtMessages(ctx context.Context, in *BulkGetCaughtMessagesRequest) (*BulkGetCaughtMessagesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "BulkGetCaughtMessages")
	out := new(BulkGetCaughtMessagesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[2], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) ListCaughtMessagesBySender(ctx context.Context, in *ListCaughtMessagesBySenderRequest) (*ListCaughtMessagesBySenderResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ListCaughtMessagesBySender")
	out := new(ListCaughtMessagesBySenderResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[3], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) GetChannelAutoModProperties(ctx context.Context, in *GetChannelAutoModPropertiesRequest) (*GetChannelAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelAutoModProperties")
	out := new(GetChannelAutoModPropertiesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[4], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) SetChannelAutoModProperties(ctx context.Context, in *SetChannelAutoModPropertiesRequest) (*SetChannelAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelAutoModProperties")
	out := new(SetChannelAutoModPropertiesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[5], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) SetChannelSiftAutoModProperties(ctx context.Context, in *SetChannelSiftAutoModPropertiesRequest) (*SetChannelSiftAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelSiftAutoModProperties")
	out := new(SetChannelSiftAutoModPropertiesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[6], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) GetChannelSiftAutoModProperties(ctx context.Context, in *GetChannelSiftAutoModPropertiesRequest) (*GetChannelSiftAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelSiftAutoModProperties")
	out := new(GetChannelSiftAutoModPropertiesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[7], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) DeleteChannelAutoModProperties(ctx context.Context, in *DeleteChannelAutoModPropertiesRequest) (*DeleteChannelAutoModPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelAutoModProperties")
	out := new(DeleteChannelAutoModPropertiesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[8], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) EnableDefaultAutoModLevel(ctx context.Context, in *EnableDefaultAutoModLevelRequest) (*EnableDefaultAutoModLevelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "EnableDefaultAutoModLevel")
	out := new(EnableDefaultAutoModLevelResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[9], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) AllyEnforcement(ctx context.Context, in *AllyEnforcementRequest) (*AllyEnforcementResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcement")
	out := new(AllyEnforcementResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[10], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) AllyEnforcementBucketMember(ctx context.Context, in *AllyEnforcementBucketMemberRequest) (*AllyEnforcementBucketMemberResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcementBucketMember")
	out := new(AllyEnforcementBucketMemberResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[11], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) GetGlobalBlockedTerms(ctx context.Context, in *GetGlobalBlockedTermsRequest) (*GetGlobalBlockedTermsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "GetGlobalBlockedTerms")
	out := new(GetGlobalBlockedTermsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[12], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) AddGlobalBlockedTerm(ctx context.Context, in *AddGlobalBlockedTermRequest) (*AddGlobalBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AddGlobalBlockedTerm")
	out := new(AddGlobalBlockedTermResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[13], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) DeleteGlobalBlockedTerm(ctx context.Context, in *DeleteGlobalBlockedTermRequest) (*DeleteGlobalBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteGlobalBlockedTerm")
	out := new(DeleteGlobalBlockedTermResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[14], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) ListChannelBlockedTerms(ctx context.Context, in *ListChannelBlockedTermsRequest) (*ListChannelBlockedTermsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelBlockedTerms")
	out := new(ListChannelBlockedTermsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[15], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) ListChannelPermittedTerms(ctx context.Context, in *ListChannelPermittedTermsRequest) (*ListChannelPermittedTermsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelPermittedTerms")
	out := new(ListChannelPermittedTermsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[16], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) TestAutoModEnforcementOnMessage(ctx context.Context, in *TestAutoModEnforcementOnMessageRequest) (*TestAutoModEnforcementOnMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "TestAutoModEnforcementOnMessage")
	out := new(TestAutoModEnforcementOnMessageResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[17], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) AddChannelBlockedTerm(ctx context.Context, in *AddChannelBlockedTermRequest) (*AddChannelBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelBlockedTerm")
	out := new(AddChannelBlockedTermResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[18], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) AddChannelPermittedTerm(ctx context.Context, in *AddChannelPermittedTermRequest) (*AddChannelPermittedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelPermittedTerm")
	out := new(AddChannelPermittedTermResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[19], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) DeleteChannelBlockedTerm(ctx context.Context, in *DeleteChannelBlockedTermRequest) (*DeleteChannelBlockedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelBlockedTerm")
	out := new(DeleteChannelBlockedTermResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[20], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) DeleteChannelPermittedTerm(ctx context.Context, in *DeleteChannelPermittedTermRequest) (*DeleteChannelPermittedTermResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelPermittedTerm")
	out := new(DeleteChannelPermittedTermResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[21], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) EvaluateMessage(ctx context.Context, in *EvaluateMessageRequest) (*EvaluateMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateMessage")
	out := new(EvaluateMessageResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[22], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) ValidateAutoModContent(ctx context.Context, in *ValidateAutoModContentRequest) (*ValidateAutoModContentResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "ValidateAutoModContent")
	out := new(ValidateAutoModContentResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[23], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyAutoModJSONClient) DeleteValidatedAutoModContent(ctx context.Context, in *DeleteValidatedAutoModContentRequest) (*DeleteValidatedAutoModContentResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteValidatedAutoModContent")
	out := new(DeleteValidatedAutoModContentResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[24], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// ==================================
// TwitchSafetyAutoMod Server Handler
// ==================================

type twitchSafetyAutoModServer struct {
	TwitchSafetyAutoMod
	hooks *twirp.ServerHooks
}

func NewTwitchSafetyAutoModServer(svc TwitchSafetyAutoMod, hooks *twirp.ServerHooks) TwirpServer {
	return &twitchSafetyAutoModServer{
		TwitchSafetyAutoMod: svc,
		hooks:               hooks,
	}
}

// writeError writes an HTTP response with a valid Twirp error format, and triggers hooks.
// If err is not a twirp.Error, it will get wrapped with twirp.InternalErrorWith(err)
func (s *twitchSafetyAutoModServer) writeError(ctx context.Context, resp http.ResponseWriter, err error) {
	writeError(ctx, resp, err, s.hooks)
}

// TwitchSafetyAutoModPathPrefix is used for all URL paths on a twirp TwitchSafetyAutoMod server.
// Requests are always: POST TwitchSafetyAutoModPathPrefix/method
// It can be used in an HTTP mux to route twirp requests along with non-twirp requests on other routes.
const TwitchSafetyAutoModPathPrefix = "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/"

func (s *twitchSafetyAutoModServer) ServeHTTP(resp http.ResponseWriter, req *http.Request) {
	ctx := req.Context()
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetyautomod")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyAutoMod")
	ctx = ctxsetters.WithResponseWriter(ctx, resp)

	var err error
	ctx, err = callRequestReceived(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	if req.Method != "POST" {
		msg := fmt.Sprintf("unsupported method %q (only POST is allowed)", req.Method)
		err = badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, err)
		return
	}

	switch req.URL.Path {
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/CreateCaughtMessage":
		s.serveCreateCaughtMessage(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/UpdateCaughtMessages":
		s.serveUpdateCaughtMessages(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/BulkGetCaughtMessages":
		s.serveBulkGetCaughtMessages(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/ListCaughtMessagesBySender":
		s.serveListCaughtMessagesBySender(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/GetChannelAutoModProperties":
		s.serveGetChannelAutoModProperties(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/SetChannelAutoModProperties":
		s.serveSetChannelAutoModProperties(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/SetChannelSiftAutoModProperties":
		s.serveSetChannelSiftAutoModProperties(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/GetChannelSiftAutoModProperties":
		s.serveGetChannelSiftAutoModProperties(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/DeleteChannelAutoModProperties":
		s.serveDeleteChannelAutoModProperties(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/EnableDefaultAutoModLevel":
		s.serveEnableDefaultAutoModLevel(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/AllyEnforcement":
		s.serveAllyEnforcement(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/AllyEnforcementBucketMember":
		s.serveAllyEnforcementBucketMember(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/GetGlobalBlockedTerms":
		s.serveGetGlobalBlockedTerms(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/AddGlobalBlockedTerm":
		s.serveAddGlobalBlockedTerm(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/DeleteGlobalBlockedTerm":
		s.serveDeleteGlobalBlockedTerm(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/ListChannelBlockedTerms":
		s.serveListChannelBlockedTerms(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/ListChannelPermittedTerms":
		s.serveListChannelPermittedTerms(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/TestAutoModEnforcementOnMessage":
		s.serveTestAutoModEnforcementOnMessage(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/AddChannelBlockedTerm":
		s.serveAddChannelBlockedTerm(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/AddChannelPermittedTerm":
		s.serveAddChannelPermittedTerm(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/DeleteChannelBlockedTerm":
		s.serveDeleteChannelBlockedTerm(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/DeleteChannelPermittedTerm":
		s.serveDeleteChannelPermittedTerm(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/EvaluateMessage":
		s.serveEvaluateMessage(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/ValidateAutoModContent":
		s.serveValidateAutoModContent(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetyautomod.TwitchSafetyAutoMod/DeleteValidatedAutoModContent":
		s.serveDeleteValidatedAutoModContent(ctx, resp, req)
		return
	default:
		msg := fmt.Sprintf("no handler for path %q", req.URL.Path)
		err = badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, err)
		return
	}
}

func (s *twitchSafetyAutoModServer) serveCreateCaughtMessage(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveCreateCaughtMessageJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveCreateCaughtMessageProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveCreateCaughtMessageJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateCaughtMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(CreateCaughtMessageRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *CreateCaughtMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.CreateCaughtMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *CreateCaughtMessageResponse and nil error while calling CreateCaughtMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveCreateCaughtMessageProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateCaughtMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(CreateCaughtMessageRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *CreateCaughtMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.CreateCaughtMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *CreateCaughtMessageResponse and nil error while calling CreateCaughtMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveUpdateCaughtMessages(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveUpdateCaughtMessagesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveUpdateCaughtMessagesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveUpdateCaughtMessagesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "UpdateCaughtMessages")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(UpdateCaughtMessagesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *UpdateCaughtMessagesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.UpdateCaughtMessages(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *UpdateCaughtMessagesResponse and nil error while calling UpdateCaughtMessages. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveUpdateCaughtMessagesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "UpdateCaughtMessages")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(UpdateCaughtMessagesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *UpdateCaughtMessagesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.UpdateCaughtMessages(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *UpdateCaughtMessagesResponse and nil error while calling UpdateCaughtMessages. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveBulkGetCaughtMessages(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveBulkGetCaughtMessagesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveBulkGetCaughtMessagesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveBulkGetCaughtMessagesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "BulkGetCaughtMessages")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(BulkGetCaughtMessagesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *BulkGetCaughtMessagesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.BulkGetCaughtMessages(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *BulkGetCaughtMessagesResponse and nil error while calling BulkGetCaughtMessages. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveBulkGetCaughtMessagesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "BulkGetCaughtMessages")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(BulkGetCaughtMessagesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *BulkGetCaughtMessagesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.BulkGetCaughtMessages(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *BulkGetCaughtMessagesResponse and nil error while calling BulkGetCaughtMessages. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveListCaughtMessagesBySender(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveListCaughtMessagesBySenderJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveListCaughtMessagesBySenderProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveListCaughtMessagesBySenderJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListCaughtMessagesBySender")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(ListCaughtMessagesBySenderRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ListCaughtMessagesBySenderResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ListCaughtMessagesBySender(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListCaughtMessagesBySenderResponse and nil error while calling ListCaughtMessagesBySender. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveListCaughtMessagesBySenderProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListCaughtMessagesBySender")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(ListCaughtMessagesBySenderRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ListCaughtMessagesBySenderResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ListCaughtMessagesBySender(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListCaughtMessagesBySenderResponse and nil error while calling ListCaughtMessagesBySender. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveGetChannelAutoModProperties(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetChannelAutoModPropertiesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetChannelAutoModPropertiesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveGetChannelAutoModPropertiesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetChannelAutoModPropertiesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetChannelAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.GetChannelAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetChannelAutoModPropertiesResponse and nil error while calling GetChannelAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveGetChannelAutoModPropertiesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetChannelAutoModPropertiesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetChannelAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.GetChannelAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetChannelAutoModPropertiesResponse and nil error while calling GetChannelAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveSetChannelAutoModProperties(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveSetChannelAutoModPropertiesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveSetChannelAutoModPropertiesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveSetChannelAutoModPropertiesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(SetChannelAutoModPropertiesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *SetChannelAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.SetChannelAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *SetChannelAutoModPropertiesResponse and nil error while calling SetChannelAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveSetChannelAutoModPropertiesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(SetChannelAutoModPropertiesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *SetChannelAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.SetChannelAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *SetChannelAutoModPropertiesResponse and nil error while calling SetChannelAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveSetChannelSiftAutoModProperties(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveSetChannelSiftAutoModPropertiesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveSetChannelSiftAutoModPropertiesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveSetChannelSiftAutoModPropertiesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelSiftAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(SetChannelSiftAutoModPropertiesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *SetChannelSiftAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.SetChannelSiftAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *SetChannelSiftAutoModPropertiesResponse and nil error while calling SetChannelSiftAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveSetChannelSiftAutoModPropertiesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "SetChannelSiftAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(SetChannelSiftAutoModPropertiesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *SetChannelSiftAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.SetChannelSiftAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *SetChannelSiftAutoModPropertiesResponse and nil error while calling SetChannelSiftAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveGetChannelSiftAutoModProperties(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetChannelSiftAutoModPropertiesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetChannelSiftAutoModPropertiesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveGetChannelSiftAutoModPropertiesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelSiftAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetChannelSiftAutoModPropertiesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetChannelSiftAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.GetChannelSiftAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetChannelSiftAutoModPropertiesResponse and nil error while calling GetChannelSiftAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveGetChannelSiftAutoModPropertiesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetChannelSiftAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetChannelSiftAutoModPropertiesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetChannelSiftAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.GetChannelSiftAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetChannelSiftAutoModPropertiesResponse and nil error while calling GetChannelSiftAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelAutoModProperties(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteChannelAutoModPropertiesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteChannelAutoModPropertiesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelAutoModPropertiesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteChannelAutoModPropertiesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteChannelAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteChannelAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteChannelAutoModPropertiesResponse and nil error while calling DeleteChannelAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelAutoModPropertiesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelAutoModProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteChannelAutoModPropertiesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteChannelAutoModPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteChannelAutoModProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteChannelAutoModPropertiesResponse and nil error while calling DeleteChannelAutoModProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveEnableDefaultAutoModLevel(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveEnableDefaultAutoModLevelJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveEnableDefaultAutoModLevelProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveEnableDefaultAutoModLevelJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EnableDefaultAutoModLevel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(EnableDefaultAutoModLevelRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EnableDefaultAutoModLevelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.EnableDefaultAutoModLevel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EnableDefaultAutoModLevelResponse and nil error while calling EnableDefaultAutoModLevel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveEnableDefaultAutoModLevelProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EnableDefaultAutoModLevel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(EnableDefaultAutoModLevelRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EnableDefaultAutoModLevelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.EnableDefaultAutoModLevel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EnableDefaultAutoModLevelResponse and nil error while calling EnableDefaultAutoModLevel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAllyEnforcement(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveAllyEnforcementJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveAllyEnforcementProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveAllyEnforcementJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcement")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(AllyEnforcementRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AllyEnforcementResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AllyEnforcement(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AllyEnforcementResponse and nil error while calling AllyEnforcement. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAllyEnforcementProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcement")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(AllyEnforcementRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AllyEnforcementResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AllyEnforcement(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AllyEnforcementResponse and nil error while calling AllyEnforcement. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAllyEnforcementBucketMember(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveAllyEnforcementBucketMemberJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveAllyEnforcementBucketMemberProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveAllyEnforcementBucketMemberJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcementBucketMember")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(AllyEnforcementBucketMemberRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AllyEnforcementBucketMemberResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AllyEnforcementBucketMember(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AllyEnforcementBucketMemberResponse and nil error while calling AllyEnforcementBucketMember. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAllyEnforcementBucketMemberProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AllyEnforcementBucketMember")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(AllyEnforcementBucketMemberRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AllyEnforcementBucketMemberResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AllyEnforcementBucketMember(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AllyEnforcementBucketMemberResponse and nil error while calling AllyEnforcementBucketMember. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveGetGlobalBlockedTerms(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetGlobalBlockedTermsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetGlobalBlockedTermsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveGetGlobalBlockedTermsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetGlobalBlockedTerms")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetGlobalBlockedTermsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetGlobalBlockedTermsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.GetGlobalBlockedTerms(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetGlobalBlockedTermsResponse and nil error while calling GetGlobalBlockedTerms. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveGetGlobalBlockedTermsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetGlobalBlockedTerms")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetGlobalBlockedTermsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetGlobalBlockedTermsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.GetGlobalBlockedTerms(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetGlobalBlockedTermsResponse and nil error while calling GetGlobalBlockedTerms. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAddGlobalBlockedTerm(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveAddGlobalBlockedTermJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveAddGlobalBlockedTermProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveAddGlobalBlockedTermJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AddGlobalBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(AddGlobalBlockedTermRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AddGlobalBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AddGlobalBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AddGlobalBlockedTermResponse and nil error while calling AddGlobalBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAddGlobalBlockedTermProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AddGlobalBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(AddGlobalBlockedTermRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AddGlobalBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AddGlobalBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AddGlobalBlockedTermResponse and nil error while calling AddGlobalBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteGlobalBlockedTerm(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteGlobalBlockedTermJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteGlobalBlockedTermProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveDeleteGlobalBlockedTermJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteGlobalBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteGlobalBlockedTermRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteGlobalBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteGlobalBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteGlobalBlockedTermResponse and nil error while calling DeleteGlobalBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteGlobalBlockedTermProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteGlobalBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteGlobalBlockedTermRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteGlobalBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteGlobalBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteGlobalBlockedTermResponse and nil error while calling DeleteGlobalBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveListChannelBlockedTerms(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveListChannelBlockedTermsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveListChannelBlockedTermsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveListChannelBlockedTermsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelBlockedTerms")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(ListChannelBlockedTermsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ListChannelBlockedTermsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ListChannelBlockedTerms(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListChannelBlockedTermsResponse and nil error while calling ListChannelBlockedTerms. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveListChannelBlockedTermsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelBlockedTerms")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(ListChannelBlockedTermsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ListChannelBlockedTermsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ListChannelBlockedTerms(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListChannelBlockedTermsResponse and nil error while calling ListChannelBlockedTerms. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveListChannelPermittedTerms(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveListChannelPermittedTermsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveListChannelPermittedTermsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveListChannelPermittedTermsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelPermittedTerms")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(ListChannelPermittedTermsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ListChannelPermittedTermsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ListChannelPermittedTerms(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListChannelPermittedTermsResponse and nil error while calling ListChannelPermittedTerms. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveListChannelPermittedTermsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListChannelPermittedTerms")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(ListChannelPermittedTermsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ListChannelPermittedTermsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ListChannelPermittedTerms(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListChannelPermittedTermsResponse and nil error while calling ListChannelPermittedTerms. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveTestAutoModEnforcementOnMessage(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveTestAutoModEnforcementOnMessageJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveTestAutoModEnforcementOnMessageProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveTestAutoModEnforcementOnMessageJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "TestAutoModEnforcementOnMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(TestAutoModEnforcementOnMessageRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *TestAutoModEnforcementOnMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.TestAutoModEnforcementOnMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *TestAutoModEnforcementOnMessageResponse and nil error while calling TestAutoModEnforcementOnMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveTestAutoModEnforcementOnMessageProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "TestAutoModEnforcementOnMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(TestAutoModEnforcementOnMessageRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *TestAutoModEnforcementOnMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.TestAutoModEnforcementOnMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *TestAutoModEnforcementOnMessageResponse and nil error while calling TestAutoModEnforcementOnMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAddChannelBlockedTerm(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveAddChannelBlockedTermJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveAddChannelBlockedTermProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveAddChannelBlockedTermJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(AddChannelBlockedTermRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AddChannelBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AddChannelBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AddChannelBlockedTermResponse and nil error while calling AddChannelBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAddChannelBlockedTermProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(AddChannelBlockedTermRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AddChannelBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AddChannelBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AddChannelBlockedTermResponse and nil error while calling AddChannelBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAddChannelPermittedTerm(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveAddChannelPermittedTermJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveAddChannelPermittedTermProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveAddChannelPermittedTermJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelPermittedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(AddChannelPermittedTermRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AddChannelPermittedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AddChannelPermittedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AddChannelPermittedTermResponse and nil error while calling AddChannelPermittedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveAddChannelPermittedTermProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "AddChannelPermittedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(AddChannelPermittedTermRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *AddChannelPermittedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.AddChannelPermittedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *AddChannelPermittedTermResponse and nil error while calling AddChannelPermittedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelBlockedTerm(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteChannelBlockedTermJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteChannelBlockedTermProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelBlockedTermJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteChannelBlockedTermRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteChannelBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteChannelBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteChannelBlockedTermResponse and nil error while calling DeleteChannelBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelBlockedTermProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelBlockedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteChannelBlockedTermRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteChannelBlockedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteChannelBlockedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteChannelBlockedTermResponse and nil error while calling DeleteChannelBlockedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelPermittedTerm(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteChannelPermittedTermJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteChannelPermittedTermProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelPermittedTermJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelPermittedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteChannelPermittedTermRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteChannelPermittedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteChannelPermittedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteChannelPermittedTermResponse and nil error while calling DeleteChannelPermittedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteChannelPermittedTermProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteChannelPermittedTerm")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteChannelPermittedTermRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteChannelPermittedTermResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteChannelPermittedTerm(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteChannelPermittedTermResponse and nil error while calling DeleteChannelPermittedTerm. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveEvaluateMessage(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveEvaluateMessageJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveEvaluateMessageProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveEvaluateMessageJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(EvaluateMessageRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EvaluateMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.EvaluateMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EvaluateMessageResponse and nil error while calling EvaluateMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveEvaluateMessageProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(EvaluateMessageRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EvaluateMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.EvaluateMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EvaluateMessageResponse and nil error while calling EvaluateMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveValidateAutoModContent(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveValidateAutoModContentJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveValidateAutoModContentProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveValidateAutoModContentJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ValidateAutoModContent")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(ValidateAutoModContentRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ValidateAutoModContentResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ValidateAutoModContent(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ValidateAutoModContentResponse and nil error while calling ValidateAutoModContent. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveValidateAutoModContentProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ValidateAutoModContent")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(ValidateAutoModContentRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ValidateAutoModContentResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.ValidateAutoModContent(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ValidateAutoModContentResponse and nil error while calling ValidateAutoModContent. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteValidatedAutoModContent(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteValidatedAutoModContentJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteValidatedAutoModContentProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyAutoModServer) serveDeleteValidatedAutoModContentJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteValidatedAutoModContent")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteValidatedAutoModContentRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteValidatedAutoModContentResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteValidatedAutoModContent(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteValidatedAutoModContentResponse and nil error while calling DeleteValidatedAutoModContent. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) serveDeleteValidatedAutoModContentProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteValidatedAutoModContent")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteValidatedAutoModContentRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteValidatedAutoModContentResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyAutoMod.DeleteValidatedAutoModContent(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteValidatedAutoModContentResponse and nil error while calling DeleteValidatedAutoModContent. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyAutoModServer) ServiceDescriptor() ([]byte, int) {
	return twirpFileDescriptor0, 0
}

func (s *twitchSafetyAutoModServer) ProtocGenTwirpVersion() string {
	return "v5.12.1"
}

func (s *twitchSafetyAutoModServer) PathPrefix() string {
	return TwitchSafetyAutoModPathPrefix
}

// =====
// Utils
// =====

// HTTPClient is the interface used by generated clients to send HTTP requests.
// It is fulfilled by *(net/http).Client, which is sufficient for most users.
// Users can provide their own implementation for special retry policies.
//
// HTTPClient implementations should not follow redirects. Redirects are
// automatically disabled if *(net/http).Client is passed to client
// constructors. See the withoutRedirects function in this file for more
// details.
type HTTPClient interface {
	Do(req *http.Request) (*http.Response, error)
}

// TwirpServer is the interface generated server structs will support: they're
// HTTP handlers with additional methods for accessing metadata about the
// service. Those accessors are a low-level API for building reflection tools.
// Most people can think of TwirpServers as just http.Handlers.
type TwirpServer interface {
	http.Handler
	// ServiceDescriptor returns gzipped bytes describing the .proto file that
	// this service was generated from. Once unzipped, the bytes can be
	// unmarshalled as a
	// github.com/golang/protobuf/protoc-gen-go/descriptor.FileDescriptorProto.
	//
	// The returned integer is the index of this particular service within that
	// FileDescriptorProto's 'Service' slice of ServiceDescriptorProtos. This is a
	// low-level field, expected to be used for reflection.
	ServiceDescriptor() ([]byte, int)
	// ProtocGenTwirpVersion is the semantic version string of the version of
	// twirp used to generate this file.
	ProtocGenTwirpVersion() string
	// PathPrefix returns the HTTP URL path prefix for all methods handled by this
	// service. This can be used with an HTTP mux to route twirp requests
	// alongside non-twirp requests on one HTTP listener.
	PathPrefix() string
}

// WriteError writes an HTTP response with a valid Twirp error format (code, msg, meta).
// Useful outside of the Twirp server (e.g. http middleware), but does not trigger hooks.
// If err is not a twirp.Error, it will get wrapped with twirp.InternalErrorWith(err)
func WriteError(resp http.ResponseWriter, err error) {
	writeError(context.Background(), resp, err, nil)
}

// writeError writes Twirp errors in the response and triggers hooks.
func writeError(ctx context.Context, resp http.ResponseWriter, err error, hooks *twirp.ServerHooks) {
	// Non-twirp errors are wrapped as Internal (default)
	twerr, ok := err.(twirp.Error)
	if !ok {
		twerr = twirp.InternalErrorWith(err)
	}

	statusCode := twirp.ServerHTTPStatusFromErrorCode(twerr.Code())
	ctx = ctxsetters.WithStatusCode(ctx, statusCode)
	ctx = callError(ctx, hooks, twerr)

	respBody := marshalErrorToJSON(twerr)

	resp.Header().Set("Content-Type", "application/json") // Error responses are always JSON
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBody)))
	resp.WriteHeader(statusCode) // set HTTP status code and send response

	_, writeErr := resp.Write(respBody)
	if writeErr != nil {
		// We have three options here. We could log the error, call the Error
		// hook, or just silently ignore the error.
		//
		// Logging is unacceptable because we don't have a user-controlled
		// logger; writing out to stderr without permission is too rude.
		//
		// Calling the Error hook would confuse users: it would mean the Error
		// hook got called twice for one request, which is likely to lead to
		// duplicated log messages and metrics, no matter how well we document
		// the behavior.
		//
		// Silently ignoring the error is our least-bad option. It's highly
		// likely that the connection is broken and the original 'err' says
		// so anyway.
		_ = writeErr
	}

	callResponseSent(ctx, hooks)
}

// urlBase helps ensure that addr specifies a scheme. If it is unparsable
// as a URL, it returns addr unchanged.
func urlBase(addr string) string {
	// If the addr specifies a scheme, use it. If not, default to
	// http. If url.Parse fails on it, return it unchanged.
	url, err := url.Parse(addr)
	if err != nil {
		return addr
	}
	if url.Scheme == "" {
		url.Scheme = "http"
	}
	return url.String()
}

// getCustomHTTPReqHeaders retrieves a copy of any headers that are set in
// a context through the twirp.WithHTTPRequestHeaders function.
// If there are no headers set, or if they have the wrong type, nil is returned.
func getCustomHTTPReqHeaders(ctx context.Context) http.Header {
	header, ok := twirp.HTTPRequestHeaders(ctx)
	if !ok || header == nil {
		return nil
	}
	copied := make(http.Header)
	for k, vv := range header {
		if vv == nil {
			copied[k] = nil
			continue
		}
		copied[k] = make([]string, len(vv))
		copy(copied[k], vv)
	}
	return copied
}

// newRequest makes an http.Request from a client, adding common headers.
func newRequest(ctx context.Context, url string, reqBody io.Reader, contentType string) (*http.Request, error) {
	req, err := http.NewRequest("POST", url, reqBody)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if customHeader := getCustomHTTPReqHeaders(ctx); customHeader != nil {
		req.Header = customHeader
	}
	req.Header.Set("Accept", contentType)
	req.Header.Set("Content-Type", contentType)
	req.Header.Set("Twirp-Version", "v5.12.1")
	return req, nil
}

// JSON serialization for errors
type twerrJSON struct {
	Code string            `json:"code"`
	Msg  string            `json:"msg"`
	Meta map[string]string `json:"meta,omitempty"`
}

// marshalErrorToJSON returns JSON from a twirp.Error, that can be used as HTTP error response body.
// If serialization fails, it will use a descriptive Internal error instead.
func marshalErrorToJSON(twerr twirp.Error) []byte {
	// make sure that msg is not too large
	msg := twerr.Msg()
	if len(msg) > 1e6 {
		msg = msg[:1e6]
	}

	tj := twerrJSON{
		Code: string(twerr.Code()),
		Msg:  msg,
		Meta: twerr.MetaMap(),
	}

	buf, err := json.Marshal(&tj)
	if err != nil {
		buf = []byte("{\"type\": \"" + twirp.Internal + "\", \"msg\": \"There was an error but it could not be serialized into JSON\"}") // fallback
	}

	return buf
}

// errorFromResponse builds a twirp.Error from a non-200 HTTP response.
// If the response has a valid serialized Twirp error, then it's returned.
// If not, the response status code is used to generate a similar twirp
// error. See twirpErrorFromIntermediary for more info on intermediary errors.
func errorFromResponse(resp *http.Response) twirp.Error {
	statusCode := resp.StatusCode
	statusText := http.StatusText(statusCode)

	if isHTTPRedirect(statusCode) {
		// Unexpected redirect: it must be an error from an intermediary.
		// Twirp clients don't follow redirects automatically, Twirp only handles
		// POST requests, redirects should only happen on GET and HEAD requests.
		location := resp.Header.Get("Location")
		msg := fmt.Sprintf("unexpected HTTP status code %d %q received, Location=%q", statusCode, statusText, location)
		return twirpErrorFromIntermediary(statusCode, msg, location)
	}

	respBodyBytes, err := ioutil.ReadAll(resp.Body)
	if err != nil {
		return wrapInternal(err, "failed to read server error response body")
	}

	var tj twerrJSON
	dec := json.NewDecoder(bytes.NewReader(respBodyBytes))
	dec.DisallowUnknownFields()
	if err := dec.Decode(&tj); err != nil || tj.Code == "" {
		// Invalid JSON response; it must be an error from an intermediary.
		msg := fmt.Sprintf("Error from intermediary with HTTP status code %d %q", statusCode, statusText)
		return twirpErrorFromIntermediary(statusCode, msg, string(respBodyBytes))
	}

	errorCode := twirp.ErrorCode(tj.Code)
	if !twirp.IsValidErrorCode(errorCode) {
		msg := "invalid type returned from server error response: " + tj.Code
		return twirp.InternalError(msg).WithMeta("body", string(respBodyBytes))
	}

	twerr := twirp.NewError(errorCode, tj.Msg)
	for k, v := range tj.Meta {
		twerr = twerr.WithMeta(k, v)
	}
	return twerr
}

// twirpErrorFromIntermediary maps HTTP errors from non-twirp sources to twirp errors.
// The mapping is similar to gRPC: https://github.com/grpc/grpc/blob/master/doc/http-grpc-status-mapping.md.
// Returned twirp Errors have some additional metadata for inspection.
func twirpErrorFromIntermediary(status int, msg string, bodyOrLocation string) twirp.Error {
	var code twirp.ErrorCode
	if isHTTPRedirect(status) { // 3xx
		code = twirp.Internal
	} else {
		switch status {
		case 400: // Bad Request
			code = twirp.Internal
		case 401: // Unauthorized
			code = twirp.Unauthenticated
		case 403: // Forbidden
			code = twirp.PermissionDenied
		case 404: // Not Found
			code = twirp.BadRoute
		case 429, 502, 503, 504: // Too Many Requests, Bad Gateway, Service Unavailable, Gateway Timeout
			code = twirp.Unavailable
		default: // All other codes
			code = twirp.Unknown
		}
	}

	twerr := twirp.NewError(code, msg)
	twerr = twerr.WithMeta("http_error_from_intermediary", "true") // to easily know if this error was from intermediary
	twerr = twerr.WithMeta("status_code", strconv.Itoa(status))
	if isHTTPRedirect(status) {
		twerr = twerr.WithMeta("location", bodyOrLocation)
	} else {
		twerr = twerr.WithMeta("body", bodyOrLocation)
	}
	return twerr
}

func isHTTPRedirect(status int) bool {
	return status >= 300 && status <= 399
}

// wrapInternal wraps an error with a prefix as an Internal error.
// The original error cause is accessible by github.com/pkg/errors.Cause.
func wrapInternal(err error, prefix string) twirp.Error {
	return twirp.InternalErrorWith(&wrappedError{prefix: prefix, cause: err})
}

type wrappedError struct {
	prefix string
	cause  error
}

func (e *wrappedError) Error() string { return e.prefix + ": " + e.cause.Error() }
func (e *wrappedError) Unwrap() error { return e.cause } // for go1.13 + errors.Is/As
func (e *wrappedError) Cause() error  { return e.cause } // for github.com/pkg/errors

// ensurePanicResponses makes sure that rpc methods causing a panic still result in a Twirp Internal
// error response (status 500), and error hooks are properly called with the panic wrapped as an error.
// The panic is re-raised so it can be handled normally with middleware.
func ensurePanicResponses(ctx context.Context, resp http.ResponseWriter, hooks *twirp.ServerHooks) {
	if r := recover(); r != nil {
		// Wrap the panic as an error so it can be passed to error hooks.
		// The original error is accessible from error hooks, but not visible in the response.
		err := errFromPanic(r)
		twerr := &internalWithCause{msg: "Internal service panic", cause: err}
		// Actually write the error
		writeError(ctx, resp, twerr, hooks)
		// If possible, flush the error to the wire.
		f, ok := resp.(http.Flusher)
		if ok {
			f.Flush()
		}

		panic(r)
	}
}

// errFromPanic returns the typed error if the recovered panic is an error, otherwise formats as error.
func errFromPanic(p interface{}) error {
	if err, ok := p.(error); ok {
		return err
	}
	return fmt.Errorf("panic: %v", p)
}

// internalWithCause is a Twirp Internal error wrapping an original error cause,
// but the original error message is not exposed on Msg(). The original error
// can be checked with go1.13+ errors.Is/As, and also by (github.com/pkg/errors).Unwrap
type internalWithCause struct {
	msg   string
	cause error
}

func (e *internalWithCause) Unwrap() error                               { return e.cause } // for go1.13 + errors.Is/As
func (e *internalWithCause) Cause() error                                { return e.cause } // for github.com/pkg/errors
func (e *internalWithCause) Error() string                               { return e.msg + ": " + e.cause.Error() }
func (e *internalWithCause) Code() twirp.ErrorCode                       { return twirp.Internal }
func (e *internalWithCause) Msg() string                                 { return e.msg }
func (e *internalWithCause) Meta(key string) string                      { return "" }
func (e *internalWithCause) MetaMap() map[string]string                  { return nil }
func (e *internalWithCause) WithMeta(key string, val string) twirp.Error { return e }

// malformedRequestError is used when the twirp server cannot unmarshal a request
func malformedRequestError(msg string) twirp.Error {
	return twirp.NewError(twirp.Malformed, msg)
}

// badRouteError is used when the twirp server cannot route a request
func badRouteError(msg string, method, url string) twirp.Error {
	err := twirp.NewError(twirp.BadRoute, msg)
	err = err.WithMeta("twirp_invalid_route", method+" "+url)
	return err
}

// withoutRedirects makes sure that the POST request can not be redirected.
// The standard library will, by default, redirect requests (including POSTs) if it gets a 302 or
// 303 response, and also 301s in go1.8. It redirects by making a second request, changing the
// method to GET and removing the body. This produces very confusing error messages, so instead we
// set a redirect policy that always errors. This stops Go from executing the redirect.
//
// We have to be a little careful in case the user-provided http.Client has its own CheckRedirect
// policy - if so, we'll run through that policy first.
//
// Because this requires modifying the http.Client, we make a new copy of the client and return it.
func withoutRedirects(in *http.Client) *http.Client {
	copy := *in
	copy.CheckRedirect = func(req *http.Request, via []*http.Request) error {
		if in.CheckRedirect != nil {
			// Run the input's redirect if it exists, in case it has side effects, but ignore any error it
			// returns, since we want to use ErrUseLastResponse.
			err := in.CheckRedirect(req, via)
			_ = err // Silly, but this makes sure generated code passes errcheck -blank, which some people use.
		}
		return http.ErrUseLastResponse
	}
	return &copy
}

// doProtobufRequest makes a Protobuf request to the remote Twirp service.
func doProtobufRequest(ctx context.Context, client HTTPClient, hooks *twirp.ClientHooks, url string, in, out proto.Message) (_ context.Context, err error) {
	reqBodyBytes, err := proto.Marshal(in)
	if err != nil {
		return ctx, wrapInternal(err, "failed to marshal proto request")
	}
	reqBody := bytes.NewBuffer(reqBodyBytes)
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	req, err := newRequest(ctx, url, reqBody, "application/protobuf")
	if err != nil {
		return ctx, wrapInternal(err, "could not build request")
	}
	ctx, err = callClientRequestPrepared(ctx, hooks, req)
	if err != nil {
		return ctx, err
	}

	req = req.WithContext(ctx)
	resp, err := client.Do(req)
	if err != nil {
		return ctx, wrapInternal(err, "failed to do request")
	}

	defer func() {
		cerr := resp.Body.Close()
		if err == nil && cerr != nil {
			err = wrapInternal(cerr, "failed to close response body")
		}
	}()

	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	if resp.StatusCode != 200 {
		return ctx, errorFromResponse(resp)
	}

	respBodyBytes, err := ioutil.ReadAll(resp.Body)
	if err != nil {
		return ctx, wrapInternal(err, "failed to read response body")
	}
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	if err = proto.Unmarshal(respBodyBytes, out); err != nil {
		return ctx, wrapInternal(err, "failed to unmarshal proto response")
	}
	return ctx, nil
}

// doJSONRequest makes a JSON request to the remote Twirp service.
func doJSONRequest(ctx context.Context, client HTTPClient, hooks *twirp.ClientHooks, url string, in, out proto.Message) (_ context.Context, err error) {
	reqBody := bytes.NewBuffer(nil)
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(reqBody, in); err != nil {
		return ctx, wrapInternal(err, "failed to marshal json request")
	}
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	req, err := newRequest(ctx, url, reqBody, "application/json")
	if err != nil {
		return ctx, wrapInternal(err, "could not build request")
	}
	ctx, err = callClientRequestPrepared(ctx, hooks, req)
	if err != nil {
		return ctx, err
	}

	req = req.WithContext(ctx)
	resp, err := client.Do(req)
	if err != nil {
		return ctx, wrapInternal(err, "failed to do request")
	}

	defer func() {
		cerr := resp.Body.Close()
		if err == nil && cerr != nil {
			err = wrapInternal(cerr, "failed to close response body")
		}
	}()

	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	if resp.StatusCode != 200 {
		return ctx, errorFromResponse(resp)
	}

	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(resp.Body, out); err != nil {
		return ctx, wrapInternal(err, "failed to unmarshal json response")
	}
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}
	return ctx, nil
}

// Call twirp.ServerHooks.RequestReceived if the hook is available
func callRequestReceived(ctx context.Context, h *twirp.ServerHooks) (context.Context, error) {
	if h == nil || h.RequestReceived == nil {
		return ctx, nil
	}
	return h.RequestReceived(ctx)
}

// Call twirp.ServerHooks.RequestRouted if the hook is available
func callRequestRouted(ctx context.Context, h *twirp.ServerHooks) (context.Context, error) {
	if h == nil || h.RequestRouted == nil {
		return ctx, nil
	}
	return h.RequestRouted(ctx)
}

// Call twirp.ServerHooks.ResponsePrepared if the hook is available
func callResponsePrepared(ctx context.Context, h *twirp.ServerHooks) context.Context {
	if h == nil || h.ResponsePrepared == nil {
		return ctx
	}
	return h.ResponsePrepared(ctx)
}

// Call twirp.ServerHooks.ResponseSent if the hook is available
func callResponseSent(ctx context.Context, h *twirp.ServerHooks) {
	if h == nil || h.ResponseSent == nil {
		return
	}
	h.ResponseSent(ctx)
}

// Call twirp.ServerHooks.Error if the hook is available
func callError(ctx context.Context, h *twirp.ServerHooks, err twirp.Error) context.Context {
	if h == nil || h.Error == nil {
		return ctx
	}
	return h.Error(ctx, err)
}

func callClientResponseReceived(ctx context.Context, h *twirp.ClientHooks) {
	if h == nil || h.ResponseReceived == nil {
		return
	}
	h.ResponseReceived(ctx)
}

func callClientRequestPrepared(ctx context.Context, h *twirp.ClientHooks, req *http.Request) (context.Context, error) {
	if h == nil || h.RequestPrepared == nil {
		return ctx, nil
	}
	return h.RequestPrepared(ctx, req)
}

func callClientError(ctx context.Context, h *twirp.ClientHooks, err twirp.Error) {
	if h == nil || h.Error == nil {
		return
	}
	h.Error(ctx, err)
}

var twirpFileDescriptor0 = []byte{
	// 762 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb4, 0x98, 0x4d, 0x6b, 0x14, 0x31,
	0x18, 0xc7, 0xc9, 0xc5, 0x43, 0x2e, 0xc2, 0xd4, 0xd7, 0x15, 0xf5, 0xe2, 0xb1, 0x4c, 0x41, 0x2f,
	0xe2, 0x41, 0xd8, 0x6d, 0x97, 0xf5, 0x65, 0xb7, 0xbb, 0x76, 0xb6, 0x1e, 0xbc, 0x65, 0x67, 0x9e,
	0x6d, 0xc7, 0x66, 0x26, 0xeb, 0x24, 0xd3, 0x52, 0x3f, 0x8c, 0x1f, 0x40, 0x10, 0x04, 0x41, 0x10,
	0x04, 0xc1, 0x93, 0x20, 0xf8, 0x75, 0xbc, 0xca, 0xee, 0x24, 0x34, 0xf3, 0xb6, 0x6d, 0xd2, 0x78,
	0x99, 0x4b, 0x9e, 0xfc, 0x9e, 0xff, 0x3f, 0x93, 0x3c, 0x79, 0x66, 0xf0, 0xe3, 0x90, 0x45, 0xe0,
	0xbf, 0xcd, 0xb9, 0x88, 0x53, 0x5f, 0x1c, 0x6f, 0x91, 0xe4, 0x7d, 0xba, 0x35, 0x3d, 0x89, 0x45,
	0x78, 0x18, 0x90, 0x39, 0x88, 0xd3, 0x6e, 0x2e, 0xd8, 0x88, 0x45, 0xd3, 0x93, 0x38, 0x5b, 0x6c,
	0x89, 0xe5, 0xd3, 0x5f, 0x64, 0x4c, 0x30, 0x6f, 0x53, 0xac, 0xa2, 0xfc, 0xf0, 0x90, 0xa4, 0x29,
	0xd0, 0x84, 0x45, 0x90, 0x11, 0x11, 0xb3, 0xd4, 0x2f, 0x06, 0xf8, 0x6a, 0x3a, 0xc9, 0x05, 0x4b,
	0x58, 0xd4, 0xe9, 0x1a, 0xe5, 0x09, 0x49, 0x7e, 0x70, 0x28, 0x46, 0xc0, 0x39, 0x39, 0x00, 0x5e,
	0x24, 0xec, 0x3c, 0x31, 0x42, 0xc8, 0xc4, 0x72, 0xae, 0xa1, 0x4d, 0xc8, 0x12, 0x95, 0xf5, 0xa9,
	0xd1, 0x4c, 0x38, 0x26, 0x34, 0x5f, 0xad, 0x82, 0x9c, 0xff, 0xf0, 0xef, 0x03, 0xbc, 0xd1, 0x10,
	0xee, 0x7d, 0x44, 0x78, 0x63, 0x3b, 0x03, 0x22, 0x60, 0x5b, 0x37, 0xeb, 0x3d, 0xf3, 0x4d, 0xd6,
	0xd5, 0x6f, 0x40, 0xec, 0xc1, 0xbb, 0x1c, 0xb8, 0xe8, 0x3c, 0x77, 0x40, 0xe2, 0x0b, 0x96, 0x72,
	0xf0, 0x3e, 0x21, 0x7c, 0x6d, 0x7f, 0x11, 0x55, 0xc7, 0xb9, 0x67, 0x98, 0xa3, 0x89, 0xa1, 0xe4,
	0xbe, 0x70, 0x81, 0x92, 0x7a, 0x3f, 0x23, 0x7c, 0xbd, 0x97, 0xd3, 0xa3, 0x01, 0x88, 0x8a, 0x60,
	0xc3, 0x2c, 0x8d, 0x10, 0xa5, 0xf8, 0xa5, 0x13, 0x96, 0x94, 0xfc, 0x03, 0xe1, 0xce, 0x30, 0xe6,
	0x95, 0xe1, 0xde, 0x69, 0x00, 0x69, 0x04, 0x99, 0x37, 0x36, 0xcb, 0xd5, 0x4e, 0x52, 0xe2, 0x27,
	0xee, 0x80, 0xd2, 0xc1, 0x4f, 0x84, 0xef, 0x2c, 0xfd, 0x15, 0x3c, 0xb9, 0xcf, 0x27, 0x19, 0x5b,
	0x40, 0x26, 0x62, 0xe0, 0x9e, 0x61, 0xc6, 0x35, 0x28, 0xe5, 0xe1, 0x95, 0x43, 0xa2, 0x66, 0x22,
	0x70, 0x67, 0x22, 0x70, 0x6e, 0x22, 0xb8, 0x80, 0x89, 0x3f, 0x08, 0xdf, 0x3f, 0x8b, 0x0b, 0xe2,
	0xb9, 0xa8, 0x1b, 0x99, 0xda, 0xa6, 0x6d, 0xc4, 0x29, 0x33, 0xfb, 0x8e, 0xa9, 0x9a, 0xa1, 0x81,
	0x5b, 0x43, 0x83, 0xff, 0x62, 0x68, 0x70, 0x41, 0x43, 0xbf, 0x11, 0xbe, 0xb7, 0x03, 0x14, 0x04,
	0xb4, 0xee, 0xb4, 0xc0, 0x2c, 0xf3, 0x7a, 0x9a, 0xb2, 0x33, 0x75, 0x0b, 0x95, 0x6e, 0xbe, 0x23,
	0x7c, 0xbb, 0x9f, 0x92, 0x19, 0x85, 0x1d, 0x98, 0x93, 0x9c, 0x2a, 0xe3, 0x43, 0x38, 0x06, 0xea,
	0xed, 0x9a, 0xe5, 0x6c, 0x05, 0x29, 0x0f, 0x63, 0x67, 0x3c, 0x29, 0xff, 0x03, 0xc2, 0x57, 0xbb,
	0x94, 0x9e, 0xf6, 0xd3, 0x39, 0xcb, 0x42, 0x48, 0x20, 0x15, 0xde, 0x8e, 0x59, 0x92, 0xca, 0x74,
	0x25, 0xb5, 0x7f, 0x49, 0x8a, 0x56, 0x94, 0x2a, 0x63, 0xbd, 0x3c, 0x3c, 0x02, 0x31, 0x82, 0x64,
	0x06, 0x99, 0x69, 0x51, 0x5a, 0x83, 0xb2, 0x2c, 0x4a, 0x6b, 0x89, 0xda, 0x9d, 0x3c, 0x00, 0x31,
	0xa0, 0x6c, 0x46, 0x68, 0x8f, 0xb2, 0xf0, 0x08, 0xa2, 0xe9, 0xb2, 0xd1, 0x32, 0xbd, 0x93, 0x1b,
	0x21, 0x96, 0x77, 0x72, 0x0b, 0x4b, 0x6b, 0x7b, 0xba, 0x51, 0x54, 0x8b, 0x30, 0x6d, 0x7b, 0x9a,
	0x18, 0x96, 0x6d, 0x4f, 0x33, 0x4a, 0xea, 0xfd, 0x8a, 0xf0, 0xcd, 0xe2, 0xc8, 0xd6, 0x25, 0x0f,
	0x6d, 0x4e, 0x7e, 0xab, 0xea, 0x91, 0x23, 0x9a, 0x26, 0x7c, 0xd5, 0x61, 0x14, 0xb4, 0xd2, 0xee,
	0x18, 0x5a, 0x34, 0x2a, 0x75, 0x8c, 0xa5, 0xf0, 0x56, 0x9a, 0x56, 0xf9, 0xb4, 0x98, 0x09, 0x64,
	0x49, 0x2c, 0x84, 0x92, 0xbe, 0x6b, 0x9d, 0xac, 0x0c, 0xb2, 0xac, 0x7c, 0x6b, 0x78, 0xda, 0xbd,
	0x3a, 0x05, 0xae, 0xca, 0xa2, 0x76, 0x84, 0xc7, 0xa9, 0xfa, 0x20, 0x31, 0xbc, 0x32, 0xce, 0xc1,
	0x59, 0xde, 0xab, 0xe7, 0x52, 0xb5, 0x22, 0xd3, 0x8d, 0xa2, 0xfa, 0x2b, 0xf3, 0xcc, 0xcf, 0x59,
	0x1d, 0x62, 0x59, 0x64, 0x5a, 0x58, 0xda, 0xde, 0x3f, 0x8b, 0x28, 0xbd, 0x28, 0xd3, 0xbd, 0xdf,
	0x82, 0xb1, 0xdc, 0xfb, 0xad, 0x34, 0x29, 0xfc, 0x1b, 0xc2, 0xb7, 0x4a, 0x0d, 0x82, 0xbe, 0xdc,
	0xa3, 0x4b, 0x34, 0x1a, 0x0d, 0x2b, 0xbe, 0xeb, 0x0a, 0xa7, 0x7d, 0x6d, 0x95, 0x82, 0xca, 0xeb,
	0x3e, 0xbe, 0x44, 0xba, 0xc6, 0xa5, 0x9f, 0xb8, 0x03, 0x6a, 0x4d, 0x4b, 0xbf, 0xf8, 0xdb, 0x00,
	0xea, 0xa8, 0x1a, 0x36, 0x2d, 0x95, 0xe9, 0x96, 0x4d, 0x4b, 0x8d, 0x22, 0x05, 0x7e, 0x41, 0xf8,
	0xc6, 0x6b, 0x42, 0xe3, 0xe5, 0x67, 0xba, 0x3c, 0xba, 0xdb, 0x2c, 0x15, 0xcb, 0xe6, 0xca, 0xf0,
	0xfc, 0x34, 0x53, 0x94, 0xdc, 0xa1, 0x1b, 0x98, 0x54, 0xfd, 0x0b, 0xe1, 0xbb, 0xc5, 0xea, 0xab,
	0xc0, 0xa8, 0x22, 0x7e, 0xcf, 0xe6, 0x55, 0xb6, 0xc0, 0x94, 0x87, 0xc0, 0x29, 0xb3, 0xb0, 0xd2,
	0xf3, 0xdf, 0x6c, 0x9a, 0xfc, 0xbb, 0x9a, 0x5d, 0x59, 0xfd, 0xb0, 0x7a, 0xf4, 0x2f, 0x00, 0x00,
	0xff, 0xff, 0xad, 0xd6, 0xc1, 0xd2, 0x13, 0x14, 0x00, 0x00,
}
